#include "fenetre_parametres.h"


///////////////////////////////////////////
// Creation de l'objet
PARAMETRES::PARAMETRES(QWidget *parent) : QDialog(parent)
{
        ui.setupUi(this);

  // on charge les donnees sur le disque dur
  charger();
}



///////////////////////////////////////////
// Fermer la fenetre et enregistrer
void PARAMETRES::on_pushButton_clicked()
{
  // on ferme la fenetre
  this->hide();

  // on sauve les resultats sur le disque dur
  sauver();

} 



///////////////////////////////////////////
// Sauver les donnees sur le disque dur
void PARAMETRES::sauver(void)
{
  // recuperation des donnees
  QString value1 = ui.lineEdit->text(); 
  QString value2 = ui.lineEdit_2->text(); 

  if(value1.toDouble() < 0) // minimum 0
    value1 = "0";
  else if(value1.toDouble() > 200) // maximum 200
    value1 = "200";
  ui.lineEdit->setText(value1); 

  if(value2.toDouble() < 0) // minimum 0
    value2 = "0";
  else if(value2.toDouble() > 200) // maximum 200
    value2 = "200";
  ui.lineEdit_2->setText(value2); 

  QFile file;
  file.setFileName("config/config_parametres.ini");
  if( file.exists() )
    file.remove();
  file.open(QIODevice::Append | QIODevice::Text );
  QTextStream out(&file);
  out << value1 << endl;    
  out << value2;    
  file.close();

} 


///////////////////////////////////////////
// Charger les donnees sur le disque dur
void PARAMETRES::charger(void)
{
  QFile file;
  file.setFileName("config/config_parametres.ini");
  if( !file.exists() )
    return;      

  // creation des variables
  int value1 = 0; 
  int value2 = 50; 

  file.open(QIODevice::ReadOnly | QIODevice::Text );
  QTextStream in(&file);
  QString line;
  line = in.readLine(); 
  value1 = line.toInt();
  line = in.readLine(); 
  value2 = line.toInt();
  file.close();

  ui.lineEdit->setText(QString::number(value1)); 
  ui.lineEdit_2->setText(QString::number(value2)); 
} 


///////////////////////////////////////////
// Donne la borne min
int PARAMETRES::communique_valeur1(void)
{
  QString value1 = ui.lineEdit->text(); 
  int valeur = value1.toInt();

  if(valeur < 0) // minimum 0
    return 0;
  else if(valeur > 200) // maximum 200
    return 200;
  else
    return valeur;

}

///////////////////////////////////////////
// Donne la borne max
int PARAMETRES::communique_valeur2(void)
{
  QString value2 = ui.lineEdit_2->text(); 
  int valeur = value2.toInt();

  if(valeur < 0) // minimum 0
    return 0;
  else if(valeur > 200) // maximum 200
    return 200;
  else
    return valeur;

}
