/////////////////////////////////////////////
// Unite de pression
QString QUADREX200::choixparametre(QString lettre)
{

//Pour connaitre le gain de l'affichage analogique
//STX/P/0/TRM

//Pour connaitre le balayage de l'affichage analogique
//STx/P/1/TRM
//0 ==> trs lente
//1 ==> lente
//2 ==> normale
//3 ==> rapide
//4 ==> trs rapide

//Pour connaitre le centre de masse de l'affichage analogique
//STX/P/3/TRM

//Pour connaitre la largeur de l'affichage analogique
//STx/P/4/TRM
//0 ==> 10
//1 ==> 20
//2 ==> 40
//3 ==> 50
//4 ==> 100
//6 ==> 200





  QString valeur_retour = "-1"; // par defaut, on met a -1
  QString message_recu;

  // on vide la memoire
  vider_rs232();

  // envoi de <STX>
  QString commande = "\x02";
  send_rs232(commande);
  message_recu = receive_rs232();  // Reception d'un <Uns> (1F en hexa)  
  if(message_recu != "\x1F") // si c'est mauvais, on a un <ENQ> (05 en hexa)
  {
    commande = "\x18"; //< <CNL>
    send_rs232(commande);
    receive_rs232(); // reception du <EOT> (04 hexadecimal)

    commande = "\x02";
    send_rs232(commande);
    message_recu = receive_rs232();  // Reception d'un <Uns> (1F en hexa)  
  }
  else if(message_recu != "\x1F")
    return valeur_retour;

  // envoi de P
  commande = "P";
  send_rs232(commande);
  message_recu = receive_rs232();  // Reception d'un <Uns> (1F en hexa)  
  if(message_recu != "\x1F")
    return valeur_retour;
            
  // envoi du nombre
  commande = lettre;
  send_rs232(commande);
  message_recu = receive_rs232();  // Reception d'un <Uns> (1F en hexa)  
  if(message_recu != "\x1F")
    return valeur_retour;

  // <TRM>
  commande = "\x0D";
  send_rs232(commande);
  message_recu = receive_rs232();  // Reception d'un <ACK> (06 en hexa) (et eventuellement du <EOT>
  if(message_recu.contains("\x06") == FALSE)
    return valeur_retour;

  // on veut a present recevoir la valeur et le <EOT> (04 en hexa)
  // ATTENTION, le <EOT> a peut etre pu etre recupere avec le receive precedent !
  if(message_recu.contains("\x04") == FALSE )
  {
    if(message_recu.contains("\x15") == TRUE ) // test de NAK
    {
      commande = "\x18"; // <CNL>
      send_rs232(commande);
      receive_rs232(); // reception du <EOT> (04 hexadecimal)
      return valeur_retour;
    }
    message_recu = receive_rs232(); 
  }
  if(message_recu.contains("\x04") == FALSE )
    message_recu = receive_rs232(); 
  if(message_recu.contains("\x04") == FALSE )
    message_recu = receive_rs232(); 
  if(message_recu.contains("\x04") == FALSE )
    message_recu = receive_rs232(); 
  if(message_recu.contains("\x04") == FALSE )
  {
    if(message_recu.contains("\x15") == TRUE ) // test de NAK
    {
      commande = "\x18"; // <CNL>
      send_rs232(commande);
      receive_rs232(); // reception du <EOT> (04 hexadecimal)
    }
    return valeur_retour;
  }

  // on retire <EOT>
  message_recu = message_recu.replace("\x06", ""); // on supprime les caracteres de fin
  message_recu = message_recu.replace("\x04", ""); // on supprime les caracteres de fin

  if(message_recu == "")
    valeur_retour = "ok";

  return valeur_retour;
}




/////////////////////////////////////////////
// lecture de la valeur du parametre
QString QUADREX200::lectureparametre(void)
{
//STX/F/TRM

  QString valeur_retour = "-1"; // par defaut, on met a -1
  QString message_recu;

  // on vide la memoire
  vider_rs232();

  // envoi de <STX>
  QString commande = "\x02";
  send_rs232(commande);
  message_recu = receive_rs232();  // Reception d'un <Uns> (1F en hexa)  
  if(message_recu != "\x1F")
    return valeur_retour;

  // envoi de F
  commande = "F";
  send_rs232(commande);
  message_recu = receive_rs232();  // Reception d'un <Uns> (1F en hexa)  
  if(message_recu != "\x1F")
    return valeur_retour;

  // <TRM>
  commande = "\x0D";
  send_rs232(commande);
  message_recu = receive_rs232();  // Reception d'un <ACK> (06 en hexa) (et eventuellement du <EOT>
  if(message_recu.contains("\x06") == FALSE)
    return valeur_retour;

  // on veut a present recevoir la valeur et le <EOT> (04 en hexa)
  // ATTENTION, le <EOT> a peut etre pu etre recupere avec le receive precedent !
  int compteur = 0;
  while(message_recu.contains("\x04") == FALSE)
  {
    message_recu = message_recu + receive_rs232(); 
    compteur++;
    if(compteur == 200)
      break;
  }
  if(message_recu.contains("\x04") == FALSE )
  {
    if(message_recu.contains("\x15") == TRUE ) // test de NAK
    {
      commande = "\x18"; // <CNL>
      send_rs232(commande);
      receive_rs232(); // reception du <EOT> (04 hexadecimal)
      return valeur_retour;
    }
//    return valeur_retour;
  }

  // on retire <EOT>
  message_recu = message_recu.replace("\x06", ""); // on supprime les caracteres de fin
  message_recu = message_recu.replace("\x04", ""); // on supprime les caracteres de fin
  message_recu = message_recu.replace("-2", ""); // on supprime les messages d'erreur de la fonction receive

  valeur_retour = message_recu;

  return valeur_retour;
}




/////////////////////////////////////////////
// delimitation de l'index
QString QUADREX200::index(int index_min, int index_max)
{
//dlimitation des valeurs
//STX/I/1ere valeur d'index/dlimiteur/2e valeur d'index/TRM
//les valeurs d'index sont comprises entre "0" et "200".
//Le dlimiteur est un caractre non numrique quelconque (par exemple "S").

  QString valeur_retour = "-1"; // par defaut, on met a -1
  QString message_recu;

  // on vide la memoire
  vider_rs232();

  // envoi de <STX>
  QString commande = "\x02";
  send_rs232(commande);
  message_recu = receive_rs232();  // Reception d'un <Uns> (1F en hexa)  
  if(message_recu != "\x1F")
    return valeur_retour;

  // envoi de I
  commande = "I";
  send_rs232(commande);
  message_recu = receive_rs232();  // Reception d'un <Uns> (1F en hexa)  
  if(message_recu != "\x1F")
    return valeur_retour;
            
  // envoi de la borne_min
  if(index_min < 10)
  {
    commande = QString::number(index_min);
    send_rs232(commande);
    message_recu = receive_rs232();  // Reception d'un <Uns> (1F en hexa)  
    if(message_recu != "\x1F")
      return valeur_retour;
  }
  else if(index_min < 100)
  {
    commande = "";
    QString val_index = QString::number(index_min);
    QChar statuschar = val_index.at(0);
    commande.append(statuschar);
    send_rs232(commande);
    message_recu = receive_rs232();  // Reception d'un <Uns> (1F en hexa)  
    if(message_recu != "\x1F")
      return valeur_retour;

    commande = "";
    statuschar = val_index.at(1);
    commande.append(statuschar);
    send_rs232(commande);
    message_recu = receive_rs232();  // Reception d'un <Uns> (1F en hexa)  
    if(message_recu != "\x1F")
      return valeur_retour;
  }
  else
  {
    commande = "";
    QString val_index = QString::number(index_min);
    QChar statuschar = val_index.at(0);
    commande.append(statuschar);
    send_rs232(commande);
    message_recu = receive_rs232();  // Reception d'un <Uns> (1F en hexa)  
    if(message_recu != "\x1F")
      return valeur_retour;

    commande = "";
    statuschar = val_index.at(1);
    commande.append(statuschar);
    send_rs232(commande);
    message_recu = receive_rs232();  // Reception d'un <Uns> (1F en hexa)  
    if(message_recu != "\x1F")
      return valeur_retour;

    commande = "";
    statuschar = val_index.at(2);
    commande.append(statuschar);
    send_rs232(commande);
    message_recu = receive_rs232();  // Reception d'un <Uns> (1F en hexa)  
    if(message_recu != "\x1F")
      return valeur_retour;
  }

  // envoi du separateur
  commande = " ";
  send_rs232(commande);
  message_recu = receive_rs232();  // Reception d'un <Uns> (1F en hexa)  
  if(message_recu != "\x1F")
    return valeur_retour;

  // envoi de la borne_max
  if(index_max < 10)
  {
    commande = QString::number(index_max);
    send_rs232(commande);
    message_recu = receive_rs232();  // Reception d'un <Uns> (1F en hexa)  
    if(message_recu != "\x1F")
      return valeur_retour;
  }
  else if(index_max < 100)
  {
    commande = "";
    QString val_index = QString::number(index_max);
    QChar statuschar = val_index.at(0);
    commande.append(statuschar);
    send_rs232(commande);
    message_recu = receive_rs232();  // Reception d'un <Uns> (1F en hexa)  
    if(message_recu != "\x1F")
      return valeur_retour;

    commande = "";
    statuschar = val_index.at(1);
    commande.append(statuschar);
    send_rs232(commande);
    message_recu = receive_rs232();  // Reception d'un <Uns> (1F en hexa)  
    if(message_recu != "\x1F")
      return valeur_retour;
  }
  else
  {
    commande = "";
    QString val_index = QString::number(index_max);
    QChar statuschar = val_index.at(0);
    commande.append(statuschar);
    send_rs232(commande);
    message_recu = receive_rs232();  // Reception d'un <Uns> (1F en hexa)  
    if(message_recu != "\x1F")
      return valeur_retour;

    commande = "";
    statuschar = val_index.at(1);
    commande.append(statuschar);
    send_rs232(commande);
    message_recu = receive_rs232();  // Reception d'un <Uns> (1F en hexa)  
    if(message_recu != "\x1F")
      return valeur_retour;

    commande = "";
    statuschar = val_index.at(2);
    commande.append(statuschar);
    send_rs232(commande);
    message_recu = receive_rs232();  // Reception d'un <Uns> (1F en hexa)  
    if(message_recu != "\x1F")
      return valeur_retour;
  }


  // <TRM>
  commande = "\x0D";
  send_rs232(commande);
  message_recu = receive_rs232();  // Reception d'un <ACK> (06 en hexa) (et eventuellement du <EOT>
  if(message_recu.contains("\x06") == FALSE)
    return valeur_retour;

  // on veut a present recevoir la valeur et le <EOT> (04 en hexa)
  // ATTENTION, le <EOT> a peut etre pu etre recupere avec le receive precedent !
  if(message_recu.contains("\x04") == FALSE )
  {
    if(message_recu.contains("\x15") == TRUE ) // test de NAK
    {
      commande = "\x18"; // <CNL>
      send_rs232(commande);
      receive_rs232(); // reception du <EOT> (04 hexadecimal)
      return valeur_retour;
    }
    message_recu = receive_rs232(); 
  }
  if(message_recu.contains("\x04") == FALSE )
    message_recu = receive_rs232(); 
  if(message_recu.contains("\x04") == FALSE )
    message_recu = receive_rs232(); 
  if(message_recu.contains("\x04") == FALSE )
    message_recu = receive_rs232(); 
  if(message_recu.contains("\x04") == FALSE )
  {
    if(message_recu.contains("\x15") == TRUE ) // test de NAK
    {
      commande = "\x18"; // <CNL>
      send_rs232(commande);
      receive_rs232(); // reception du <EOT> (04 hexadecimal)
    }
    return valeur_retour;
  }

  // on retire <EOT>
  message_recu = message_recu.replace("\x06", ""); // on supprime les caracteres de fin
  message_recu = message_recu.replace("\x04", ""); // on supprime les caracteres de fin

  if(message_recu == "")
    valeur_retour = "ok";

  return valeur_retour;
}


/////////////////////////////////////////////
// indicateur de donnees reciproques
// ce sont les donnees stockees sur l'appareil qui seront recuperees par l'ordinateur
QString QUADREX200::reciproque(void)
{
//Si on veut travailler en mode rciproque, il faut envoyer :
//STX/A/TRM

  QString valeur_retour = "-1"; // par defaut, on met a -1
  QString message_recu;

  // on vide la memoire
  vider_rs232();

  // envoi de <STX>
  QString commande = "\x02";
  send_rs232(commande);
  message_recu = receive_rs232();  // Reception d'un <Uns> (1F en hexa)  
  if(message_recu != "\x1F") // si c'est mauvais, on a un <ENQ> (05 en hexa)
  {
    commande = "\x18"; //< <CNL>
    send_rs232(commande);
    receive_rs232(); // reception du <EOT> (04 hexadecimal)

    commande = "\x02";
    send_rs232(commande);
    message_recu = receive_rs232();  // Reception d'un <Uns> (1F en hexa)  
  }
  else if(message_recu != "\x1F")
    return valeur_retour;

  // envoi de A
  commande = "A";
  send_rs232(commande);
  message_recu = receive_rs232();  // Reception d'un <Uns> (1F en hexa)  
  if(message_recu != "\x1F")
    return valeur_retour;
            
  // <TRM>
  commande = "\x0D";
  send_rs232(commande);
  message_recu = receive_rs232();  // Reception d'un <ACK> (06 en hexa) (et eventuellement du <EOT>
  if(message_recu.contains("\x06") == FALSE)
    return valeur_retour;

  // on veut a present recevoir la valeur et le <EOT> (04 en hexa)
  // ATTENTION, le <EOT> a peut etre pu etre recupere avec le receive precedent !
  if(message_recu.contains("\x04") == FALSE )
  {
    if(message_recu.contains("\x15") == TRUE ) // test de NAK
    {
      commande = "\x18"; // <CNL>
      send_rs232(commande);
      receive_rs232(); // reception du <EOT> (04 hexadecimal)
      return valeur_retour;
    }
    message_recu = receive_rs232(); 
  }
  if(message_recu.contains("\x04") == FALSE )
    message_recu = receive_rs232(); 
  if(message_recu.contains("\x04") == FALSE )
    message_recu = receive_rs232(); 
  if(message_recu.contains("\x04") == FALSE )
    message_recu = receive_rs232(); 
  if(message_recu.contains("\x04") == FALSE )
  {
    if(message_recu.contains("\x15") == TRUE ) // test de NAK
    {
      commande = "\x18"; // <CNL>
      send_rs232(commande);
      receive_rs232(); // reception du <EOT> (04 hexadecimal)
    }
    return valeur_retour;
  }

  // on retire <EOT>
  message_recu = message_recu.replace("\x06", ""); // on supprime les caracteres de fin
  message_recu = message_recu.replace("\x04", ""); // on supprime les caracteres de fin

  if(message_recu == "")
    valeur_retour = "ok";

  return valeur_retour;
}

/////////////////////////////////////////////
// indicateur de mode reciproque
// selection analogique
QString QUADREX200::indicateurreciproque(void)
{
//Si on veut travailler en mode rciproque, il faut envoyer :
//STX/D/1/TRM

  QString valeur_retour = "-1"; // par defaut, on met a -1
  QString message_recu;

  // on vide la memoire
  vider_rs232();

  // envoi de <STX>
  QString commande = "\x02";
  send_rs232(commande);
  message_recu = receive_rs232();  // Reception d'un <Uns> (1F en hexa)  
  if(message_recu != "\x1F")
    return valeur_retour;

  // envoi de D
  commande = "D";
  send_rs232(commande);
  message_recu = receive_rs232();  // Reception d'un <Uns> (1F en hexa)  
  if(message_recu != "\x1F")
    return valeur_retour;

  // envoi de 1
  commande = "1";
  send_rs232(commande);
  message_recu = receive_rs232();  // Reception d'un <Uns> (1F en hexa)  
  if(message_recu != "\x1F")
    return valeur_retour;            
            
  // <TRM>
  commande = "\x0D";
  send_rs232(commande);
  message_recu = receive_rs232();  // Reception d'un <ACK> (06 en hexa) (et eventuellement du <EOT>
  if(message_recu.contains("\x06") == FALSE)
    return valeur_retour;

  // on veut a present recevoir la valeur et le <EOT> (04 en hexa)
  // ATTENTION, le <EOT> a peut etre pu etre recupere avec le receive precedent !
  if(message_recu.contains("\x04") == FALSE )
  {
    if(message_recu.contains("\x15") == TRUE ) // test de NAK
    {
      commande = "\x18"; // <CNL>
      send_rs232(commande);
      receive_rs232(); // reception du <EOT> (04 hexadecimal)
      return valeur_retour;
    }
    message_recu = receive_rs232(); 
  }
  if(message_recu.contains("\x04") == FALSE )
    message_recu = receive_rs232(); 
  if(message_recu.contains("\x04") == FALSE )
    message_recu = receive_rs232(); 
  if(message_recu.contains("\x04") == FALSE )
    message_recu = receive_rs232(); 
  if(message_recu.contains("\x04") == FALSE )
  {
    if(message_recu.contains("\x15") == TRUE ) // test de NAK
    {
      commande = "\x18"; // <CNL>
      send_rs232(commande);
      receive_rs232(); // reception du <EOT> (04 hexadecimal)
    }
    return valeur_retour;
  }

  // on retire <EOT>
  message_recu = message_recu.replace("\x06", ""); // on supprime les caracteres de fin
  message_recu = message_recu.replace("\x04", ""); // on supprime les caracteres de fin

  if(message_recu == "")
    valeur_retour = "ok";

  return valeur_retour;
}

/////////////////////////////////////////////
// lecture des valeurs stockees dans l'appareil
QString QUADREX200::getvaleurs(void)
{
//Si on veut travailler en mode rciproque, il faut envoyer :
//STX/G/TRM

  QString valeur_retour = "-1"; // par defaut, on met a -1
  QString message_recu;

  // on vide la memoire
  vider_rs232();

  // envoi de <STX>
  QString commande = "\x02";
  send_rs232(commande);
  message_recu = receive_rs232();  // Reception d'un <Uns> (1F en hexa)  
  if(message_recu != "\x1F")
    return valeur_retour;

  // envoi de G
  commande = "G";
  send_rs232(commande);
  message_recu = receive_rs232();  // Reception d'un <Uns> (1F en hexa)  
  if(message_recu != "\x1F")
    return valeur_retour;

  // <TRM>
  commande = "\x0D";
  send_rs232(commande);
  message_recu = receive_rs232();  // Reception d'un <ACK> (06 en hexa) (et eventuellement du <EOT>
  if(message_recu.contains("\x06") == FALSE)
    return valeur_retour;

  // on veut a present recevoir la valeur et le <EOT> (04 en hexa)
  // ATTENTION, le <EOT> a peut etre pu etre recupere avec le receive precedent !
  int compteur = 0;
  while(message_recu.contains("\x04") == FALSE)
  {
    message_recu = message_recu + receive_rs232(); 
    compteur++;
    if(compteur == 200)
      break;
  }
  if(message_recu.contains("\x04") == FALSE )
  {
    if(message_recu.contains("\x15") == TRUE ) // test de NAK
    {
      commande = "\x18"; // <CNL>
      send_rs232(commande);
      receive_rs232(); // reception du <EOT> (04 hexadecimal)
      return valeur_retour;
    }
//    return valeur_retour;
  }

  // on retire <EOT>
  message_recu = message_recu.replace("\x06", ""); // on supprime les caracteres de fin
  message_recu = message_recu.replace("\x04", ""); // on supprime les caracteres de fin
  message_recu = message_recu.replace("-2", ""); // on supprime les messages d'erreur de la fonction receive

  valeur_retour = message_recu;

  return valeur_retour;
}

