/////////////////////////////////////////////
// Envoyer vers l'appareil
int QUADREX200::send_rs232(QString la_commande)
{
  if(port == NULL)
  {
    close();
    QCoreApplication::quit();
    exit(1);
    return -1;        
  }

  QByteArray commandeByte = la_commande.toAscii();
  port->write(commandeByte);
  port->flush();

  return 0; // 0 = tout va bien et -1 = probleme
}


/////////////////////////////////////////////
// Recevoir de l'appareil
QString QUADREX200::receive_rs232(void)
{
  if(port == NULL)
  {
    // port serie inexistant
    close();
    QCoreApplication::quit();
    exit(1);
    QString valeur_retour = "-1"; // Il y a un probleme
    return valeur_retour;        
  }

  int test = 0; // 0 = rien a recuperer
  for(int xyz = 0 ; xyz < 4; xyz++)
  {
    // on regarde s'il y a quelque chose a recuperer
    if( port->size() == 0)
    {
      // on laise un delai pour voir si on ne recoit vraiment rien
      QEventLoop evtLoop;
      QTimer::singleShot(20, &evtLoop, SLOT(quit())); // 20 ms d'attente
      evtLoop.exec();
    }
    else
    {
      test = 1; // 1 = quelque chose a recuperer
      break;
    }
  }

  if( test == 0) 
  {
    // aucune donnee a lire
    printf ("Erreur - pas de donnee a lire\n");    
    return "-2";
  }


  // lecture d'une ligne
  char tableau[300];
  for(int i=0 ; i<200; i++)
    tableau[i] = '\0';
  port->readLine ( tableau, 200);  
  if (tableau[0] == '\0') // pas bon
  {
    // lecture ligne bizarre
    return "-2";
  }

  QString la_commande = tableau;

  return la_commande; 
}

/////////////////////////////////////////////
// Recevoir de l'appareil
void QUADREX200::vider_rs232(void)
{
  if(port == NULL)
    return;        

  if( port->size() == 0 && port->atEnd() == 0)
     return;

  // lecture d'une ligne
  char tableau[300];
  port->readLine ( tableau, 200);  

  return;
}
